size(500,500)
background(0.9)

var("typeface",TEXT,"Garamond_bold")
font(typeface)
var("maxsize",NUMBER,200,50,300)
var("density",NUMBER,10,1,100)
var("clustersize",NUMBER,50,10,100)
var("uppercase",BOOLEAN)

fill(0.7)
nostroke()
        
def random_glyph():
    alphabet = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    letter = random(0, 25)
    return alphabet[letter]

def random_Glyph():
    alphabet = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"]
    letter = random(0, 25)
    return alphabet[letter]

def make_heap():
    heap = None
    for i in range(int(density)):
   
        fontsize(random(30,maxsize))    
        x = random(-clustersize,clustersize)
        y = random(-clustersize,clustersize)
        if uppercase:
            path = textpath(random_Glyph(),x,y)
        else:
            path = textpath(random_glyph(),x,y)
        transform(mode=CENTER)
        t = Transform()
        t.rotate(random(360))
        path = t.transformBezierPath(path)
        if not heap:
            heap = path
        heap = heap.union(path, flatness=0)
    
    return heap
    
thepath = make_heap()
translate(250,250)
drawpath(thepath)